<?php
namespace Mageants\HyvaSimpleConfigurable\Block\Product\Renderer\Configurable;

/**
 * Interceptor class for @see \Mageants\HyvaSimpleConfigurable\Block\Product\Renderer\Configurable
 */
class Interceptor extends \Mageants\HyvaSimpleConfigurable\Block\Product\Renderer\Configurable implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Catalog\Block\Product\Context $context, \Magento\Framework\Stdlib\ArrayUtils $arrayUtils, \Magento\Framework\Json\EncoderInterface $jsonEncoder, \Magento\ConfigurableProduct\Helper\Data $helper, \Magento\Catalog\Helper\Product $catalogProduct, \Magento\Customer\Helper\Session\CurrentCustomer $currentCustomer, \Magento\Framework\Pricing\PriceCurrencyInterface $priceCurrency, \Magento\ConfigurableProduct\Model\ConfigurableAttributeData $configurableAttributeData, \Magento\Swatches\Helper\Data $swatchHelper, \Magento\Swatches\Helper\Media $swatchMediaHelper, \Mageants\SimpleConfigurable\Helper\Data $simpleConfigurableHelper, \Magento\Framework\View\LayoutFactory $layoutFactory, \Magento\Catalog\Helper\Output $output, \Magento\Catalog\Model\ProductRepository $productRepository, \Magento\Eav\Model\Config $config, \Magento\Catalog\Model\Product $productObj, \Magento\Catalog\Model\ProductFactory $productFactory, \Magento\Framework\View\DesignInterface $theme, ?\Magento\Catalog\Model\Product\Image\UrlBuilder $imageUrlBuilder = null, ?\Magento\Swatches\Model\SwatchAttributesProvider $swatchAttributesProvider = null, array $data = [])
    {
        $this->___init();
        parent::__construct($context, $arrayUtils, $jsonEncoder, $helper, $catalogProduct, $currentCustomer, $priceCurrency, $configurableAttributeData, $swatchHelper, $swatchMediaHelper, $simpleConfigurableHelper, $layoutFactory, $output, $productRepository, $config, $productObj, $productFactory, $theme, $imageUrlBuilder, $swatchAttributesProvider, $data);
    }

    /**
     * {@inheritdoc}
     */
    public function getJsonSwatchConfig()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getJsonSwatchConfig');
        return $pluginInfo ? $this->___callPlugins('getJsonSwatchConfig', func_get_args(), $pluginInfo) : parent::getJsonSwatchConfig();
    }

    /**
     * {@inheritdoc}
     */
    public function getJsonConfig()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getJsonConfig');
        return $pluginInfo ? $this->___callPlugins('getJsonConfig', func_get_args(), $pluginInfo) : parent::getJsonConfig();
    }

    /**
     * {@inheritdoc}
     */
    public function getProductPrice(\Magento\Catalog\Model\Product $product)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getProductPrice');
        return $pluginInfo ? $this->___callPlugins('getProductPrice', func_get_args(), $pluginInfo) : parent::getProductPrice($product);
    }

    /**
     * {@inheritdoc}
     */
    public function getProductDetailsHtml(\Magento\Catalog\Model\Product $product)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getProductDetailsHtml');
        return $pluginInfo ? $this->___callPlugins('getProductDetailsHtml', func_get_args(), $pluginInfo) : parent::getProductDetailsHtml($product);
    }

    /**
     * {@inheritdoc}
     */
    public function getImage($product, $imageId, $attributes = [])
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getImage');
        return $pluginInfo ? $this->___callPlugins('getImage', func_get_args(), $pluginInfo) : parent::getImage($product, $imageId, $attributes);
    }

    /**
     * {@inheritdoc}
     */
    public function getUrl($route = '', $params = [])
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getUrl');
        return $pluginInfo ? $this->___callPlugins('getUrl', func_get_args(), $pluginInfo) : parent::getUrl($route, $params);
    }

    /**
     * {@inheritdoc}
     */
    public function getData($key = '', $index = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getData');
        return $pluginInfo ? $this->___callPlugins('getData', func_get_args(), $pluginInfo) : parent::getData($key, $index);
    }
}
